@echo off
TITLE Asm Maker v2.0
color 01
if not exist "Source" MD "Source"
if not exist "Exec" MD "Exec"
if not exist "Hex" MD "Hex"
If not exist "Data" MD "Data"
cd Data
if not exist "Objhex.exe" move "..\All\OBJHEX.exe" "Objhex.exe"
if not exist "Devpac8X.com" move "..\All\Devpac8X.com" "Devpac8X.com"
if not exist "Devpac83.com" move "..\All\Devpac83.com" "Devpac83.com"
if not exist "Omnidat.inc" move "..\All\Omnidat.inc" "Omnidat.inc"
if not exist "Tasm80.tab" move "..\All\Tasm80.tab" "Tasm80.tab"
if not exist "Tasm.exe" move "..\All\Tasm.exe" "Tasm.exe"
if not exist "DoorsCS.txt" move "..\All\DoorsCS.txt" "DoorsCS.txt"
if not exist "Mirage.txt" move "..\All\Mirage.txt" "Mirage.txt"
if not exist "Ion.txt" move "..\All\Ion.txt" "Ion.txt"
if not exist "TI83.txt" move "..\All\TI83.txt" "TI83.txt"
if not exist "TSE.txt" move "..\All\TSE.txt" "TSE.txt"
if not exist "Custom.txt" move "..\All\Custom.txt" "Custom.txt"
ATTRIB +H "Objhex.exe"
ATTRIB +H "Devpac83.com"
ATTRIB +H "Devpac8X.com"
ATTRIB +H "Tasm.exe"
ATTRIB +H "Tasm80.tab"
cd..
rd "All"
cd Source
:Begin
cls
echo ----------------------------------------------
echo [             Asm Maker Version 2.0          ]
echo [          Written by Ghosuwa Wogomon        ]
echo ----------------------------------------------
echo (1)New Asm Source
echo (2)Compile Source
echo (3)Options
echo (4)Quit
set /P choose=Do:
if "%choose%" == "1" goto :New
if "%choose%" == "2" goto :Comp
if "%choose%" == "3" goto :options
if "%choose%" == "4" Exit
goto :Begin
:options
cls
echo [Options]
echo (1)New Header
echo (2)Back
set /P choose=Do:
if "%choose%" == "1" goto :nwhead
if "%choose%" == "2" goto :Begin
goto :options
:nwhead
..\Data\custom.txt
goto :Begin
:Comp
cls
echo ----------------------------------------------
echo [             Asm Maker Version 2.0          ]
echo [          Written by Ghosuwa Wogomon        ]
echo ----------------------------------------------
echo [Source Files]////////////////////////////////
dir /B
echo.
Set /P run=Assemble:
If not exist "%run%.z80" If not exist "%run%.asm" goto :NF
CLS
echo ----- Creating Hex for %run%...
echo #define TI83 >..\Data\%run%.asm
if exist %run%.asm type %run%.asm >>..\Data\%run%.asm
if exist %run%.z80 type %run%.z80 >>..\Data\%run%.asm
cd..
cd Data
tasm -80 -i -b %run%.asm %run%.bin
if errorlevel 1 goto :ERRORS
echo ----- Creating Hex for %run%...
Objhex "%run%.bin" > "..\Hex\%run%.hex"
if errorlevel 1 goto :ERRORS
echo ----- %run% Hex for %run% created.
echo ----- Assembling and Compiling %run% for the TI-83...
devpac83 %run%
echo ----- %run% for the TI-83 Assembled and Compiled.
echo ----- Assembling %run% for the TI-83/84 Plus...
echo #define TI83P >%run%.asm
if exist "..\Source\%run%.asm" type "..\Source\%run%.asm" >>%run%.asm
if exist "..\Source\%run%.z80" type "..\Source\%run%.z80" >>%run%.asm
tasm -80 -i -b %run%.asm %run%.bin
if errorlevel 1 goto :ERRORS
devpac8x %run%
echo ----- %run% for the TI-83/84 Plus Assembled and Compiled.
cls
move "%run%.83p" "..\Exec\%run%.83p"
move "%run%.8xp" "..\Exec\%run%.8xp"
echo TI-83 Version is %run%.83p
echo TI-83 Plus Version is %run%.8xp
echo Hex is %run%.hex
echo %run% has been successfully created!
pause
goto :DONE
:ERRORS
echo ----- There were errors!
pause
:err
cls
echo View Errors?
set /P ans=(Y)es (N)o:
if "%ans%" == "Y" %run%.lst
if "%ans%" == "y" %run%.lst
if "%ans%" == "Y" goto :DONE
If "%ans%" == "y" Goto :DONE
if "%ans%" == "N" goto :DONE
if "%ans%" == "n" goto :DONE
goto :err
:New
cls
set /p name=Name:
:head
cls
echo [Header]
echo (1)Ion
echo (2)TSE
echo (3)Mirage
echo (4)DoorsCS
echo (5)TI-83 Plus
echo (6)Custom
echo (7)No Header
Set /P head=Header:
cls
if "%head%" == "1" goto :ion
if "%head%" == "2" goto :tse
if "%head%" == "3" goto :mirage
if "%head%" == "4" goto :doors
if "%head%" == "5" goto :TI83
if "%head%" == "6" goto :custom
if "%head%" == "7" goto :no
goto :head
:ion
type "..\Data\ion.txt" > "%name%.z80"
goto :Edit
:tse
type "..\Data\tse.txt" > "%name%.z80"
goto :Edit
:mirage
type "..\Data\mirage.txt" > "%name%.z80"
goto :Edit
:doors
type "..\Data\DoorsCS.txt" > "%name%.z80"
goto :Edit
:TI83
type "..\Data\TI83.txt" > "%name%.z80"
goto :Edit
:custom
type "..\Data\custom.z80"  > "%name%.z80"
goto :Edit
:no
echo. > "%name%.z80"
:Edit
"C:\WINDOWS\system32\notepad" %name%.z80
GOTO :Begin
:DONE
del %run%.asm
del %run%.lst
del %run%.bin